
; ===================================================================

Captest	ident	1,0
	page	120,60,1,1,4
	opt	cc,cex,intr,mc,md,mex
	lstcol	10,,,,

; ===================================================================
	INCLUDE		'..\..\glob56.asm'
; ===================================================================
;
; X: variables
;
Tdata		equ	0
TEMP		equ	1

; ===================================================================

NULLVEC		macro
		nop
		nop
		endm

ERRVEC		macro
		jsr	>ERROR
		endm


	ORG	P:0		; bootstrap from host port

VReset	jmp	>START1		; 0000
VStkerr	ERRVEC
VTrace	ERRVEC
VSWI	ERRVEC
VIRQA	NULLVEC
VIRQB	jsr	<IRQB
VSSIr   NULLVEC
VSSIrx  NULLVEC
VSSIt   NULLVEC
VSSItx	NULLVEC
VSCIr	NULLVEC
VSCIrx	NULLVEC
VSCIt	NULLVEC
VSCIi	NULLVEC
VSCItim	NULLVEC
VNMI	NULLVEC
VHOSTR  NULLVEC
VHOSTT	NULLVEC
VHOSTC	NULLVEC
VHC1	NULLVEC
VHC2    NULLVEC
VHC3    NULLVEC
VHC4    NULLVEC
VHC5    NULLVEC
VHC6    NULLVEC
VHC7    NULLVEC
VHC8    NULLVEC
VHC9    NULLVEC
VHC10   NULLVEC
VHC11   NULLVEC
VHC12   NULLVEC

VILLEG  ERRVEC

; ===================================================================

; wait 64k*33n = 2.16msec
WAIT1	clr	a
	rep	a1
	nop
	rts

; ===================================================================

; Get a word from Host Port into A1
;
GETWORD	jclr	#M_HRDF,X:<<M_HSR,GETWORD
	movep	X:<<M_HRX,a1
	rts

;
; Put a word from X0 into Host Port
;
PUTWORD	jclr	#M_HTDE,X:<<M_HSR,PUTWORD
	movep	x0,X:<<M_HRX
	rts

; ===================================================================

IRQB	equ	*
	clr	a	#$e007,r0
	clr	b
	move	Y:(r0)-,y0
	mpy	y0,#20,a
	move	Y:(r0)-,a0
	asl	a	Y:(r0)-,y0
	mpy	y0,#20,b
	asl	a	Y:(r0)-,b0
	rep	#4
	asl	b
	asl	a	b1,Y:(r4)+
	asl	a	#$c200,r1
	move	a1,Y:(r4)+
	move	r4,y0
	mpy	y0,#8,a
	move	a1,Y:(r1)
	rti

; ===================================================================
;
; Error processing
;
ERROR   equ	*
	ori     #3,MR           ; no IRQs
	debug
	jmp	*
	rti

; ===================================================================
;
; PLL after reset: ckin=5MHz
;
START1  equ     *
	move	#>$1F000b,x0	; ck*12 = 60 MHz
	movep	x0,X:<<M_PCTL
	nop
	nop
	movep   #0,X:<<M_HCR
	movep   #0,X:<<M_PBD
	bset    #1,X:<<M_PBC    ; (re-)enable HI, PB14 I/O
	ori     #3,MR           ; no IRQs
	movec	#0,SP
	andi    #3,MR

; @60 MHz	tc=33.3n
;		1W=50.0n
;		2W=66.6n
;		3W=83.3n
;		4W=100.0n

	movep	#$0614,X:<<M_BCR
	move	#0,r0
	clr	a
	rep	#256
	move	a,L:(r0)+

; -------------------------------------------------------
;	Configure SCI for ()B, N81
;	System clock is 60.000 MHz
;	Ext.clock is 8.000 MHz
;
; X:SCR [13=TMIE 12=TIE 11=RIE 10=ILIE 9=TE 8=RE 7=WOMS 6=RWU 5=WAKE
;         4=SBK  2-0=WDS]
;
; ========== SCI ==================================
; internal ck= 16*BR
; in ck = 30.0 MHz
; SCLK out = BR
; SCCR value = (ck/64)/BR
; BPS = (f0/64) / ((SCP?8:1)*(CD+1))
;
; -------------------------------------------------------

	movep	#$0,X:<<M_PCDDR
	movep	#$0026,X:<<M_SCR	; EXT CK - WDS=010(8N1)
	movep	#$c002,X:<<M_SCCR	; EXT CK - Scale=/3 -> 250 kHz

; CRA: PSR WL(2) DC(5)  PM(8)
;       0   10   0.0000.0000.0000
	movep	#$4100,X:<<M_CRA
; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCD(4) OF(2)
;	0   0   0  0. 0   0   1   0.0    0   00.00   00
	movep	#$0200,X:<<M_CRB

; now activate SCI/SSI
	movep	#$007,X:<<M_PCC

; --------------------------------------------

; IRQ priorities:
;	SCI  = disabled
;	SSI  = disabled
;	HOST = disabled
;	IRQB = enabled, edge trig (111)
;	IRQA = disabled, edge trig (100)
; bit setting = 00.00|00.xx|xx.11|1.100		(x=0)

	movep	#>$003c,X:<<M_IPR

; ===================================================================
;
; peripherals on U43 use bits 8-15 !!
;
	MEM_MODE0
	nop
;	move	#>$425553,x0
;	jsr	<PUTWORD

	move	#$c000,r4
	move	#$1ff,m4
	nop
	andi	#$FD,MR			; IRQs lev 1,2 enabled
ELOOP   equ     *
	wait
	jmp     <ELOOP

; ===================================================================

	end

