
; ===================================================================

Flash  	ident	1,0
	page	120,60,1,1,4
	opt	cc,cex,intr,mc,md,mex
	lstcol	10,,,,

; ===================================================================
	INCLUDE		'..\glob56.asm'
; ===================================================================
;
; X: variables
;
TEMP		equ	0
Blkno		equ	1
Seccode		equ	2

; ===================================================================

NULLVEC		macro
		nop
		nop
		endm

ERRVEC		macro
		jsr	>ERROR
		endm


	ORG	P:0		; bootstrap from host port

VReset	jmp	>START1		; 0000
VStkerr	ERRVEC
VTrace	ERRVEC
VSWI	ERRVEC
VIRQA	NULLVEC
VIRQB	NULLVEC
VSSIr   NULLVEC
VSSIrx  NULLVEC
VSSIt   NULLVEC
VSSItx	NULLVEC
VSCIr	NULLVEC
VSCIrx	NULLVEC
VSCIt	NULLVEC
VSCIi	NULLVEC
VSCItim	NULLVEC
VNMI	NULLVEC
VHOSTR	ERRVEC
VHOSTT	ERRVEC

VHOSTC	jsr	>PEEK
; host aux vectors @ P:0026-003E
VHC1	jsr	>POKE		; 0026
VHC2    jsr	>FILL

VHC3    NULLVEC
VHC4    NULLVEC
VHC5    NULLVEC
VHC6    NULLVEC
VHC7    NULLVEC
VHC8    NULLVEC
VHC9    NULLVEC
VHC10   NULLVEC
VHC11   NULLVEC
VHC12   NULLVEC

VILLEG  ERRVEC

; ===================================================================

; wait 64k*50n = 3.28u
WAIT1	clr	a
	rep	a1
	nop
	rts

; ===================================================================

; Get a word from Host Port into A1
;
GETWORD	jclr	#M_HRDF,X:<<M_HSR,GETWORD
	movep	X:<<M_HRX,a1
	rts

;
; Put a word from X0 into Host Port
;
PUTWORD	jclr	#M_HTDE,X:<<M_HSR,PUTWORD
	movep	x0,X:<<M_HTX
	rts

Pkpoka	jsr     <GETWORD		; get space/address <SSAAAA>
	tfr	a,b	a1,X:<TEMP
	jsr	<GETWORD		; get word count
	move	a1,n0
	move	b1,r0
	rts

;
; PEEK: put block from S:A into Host Port
;
PEEK    equ     *
	jsr     <Pkpoka
	do	n0,Endpeek
	jset	#PP_REG,X:<TEMP,PeekPE
	jset	#PP_MP,X:<TEMP,PeekPE
	jset	#PP_MXY,X:<TEMP,PeekY
PeekX   move    X:(r0)+,x0
	jmp	<Epeek0
PeekY   move    Y:(r0)+,x0
	jmp     <Epeek0
PeekPE	movem   P:(r0)+,x0
Epeek0	jsr     <PUTWORD
	nop
Endpeek	rti

;
; POKE: get block from Host Port into S:A
;
POKE    equ     *
	jsr     <Pkpoka
	do	n0,Endpoke
	jsr     <GETWORD		; get value into A1
	jset	#PP_REG,X:<TEMP,PokePE
	jset	#PP_MP,X:<TEMP,PokePE
	jset	#PP_MXY,X:<TEMP,PokeY
PokeX   move    a1,X:(r0)+
	jmp	<Epoke0
PokeY   move    a1,Y:(r0)+
	jmp	<Epoke0
PokePE	movem   a1,P:(r0)+
Epoke0	nop
Endpoke	rti

;
; FILL: fill block from Host Port into S:A
;
FILL    equ     *
	jsr     <Pkpoka
	jsr     <GETWORD		; get value into A1
	do	n0,Endfill
	jset	#PP_REG,X:<TEMP,Efill0
	jset	#PP_MP,X:<TEMP,FillPE
	jset	#PP_MXY,X:<TEMP,FillY
FillX   move    a1,X:(r0)+
	jmp	<Efill0
FillY   move    a1,Y:(r0)+
	jmp	<Efill0
FillPE	movem   a1,P:(r0)+
Efill0	nop
Endfill	rti

; ===================================================================
;
; Error processing
;
ERROR   bset    #M_HF2,X:<<M_HCR     ; set error flag (HF23 = 11)
	bset	#M_HF3,X:<<M_HCR
	ori     #3,MR           ; no IRQs
	nop
	stop
	rti

; ===================================================================
;
SECTAB	equ	*
	dc	$300		; P:space
	dc	$200
	dc	$100
	dc	0
	dc	$300		; X:space
	dc	$200
	dc	$100
	dc	0

BUSCYC2	equ	*
	movep	#$200,Y:<<U_OR1
	move	#>$aa,x0
	move	x0,P:(FLASH+$1555)	; write $5555,$aa
	movep	#$300,Y:<<U_OR1
	move	#>$55,x0
	move	x0,P:(FLASH+$2AAA)	; write $2aaa,$55
	rts

FMEMCMD	equ	*
	jsr	<BUSCYC2
	movep	#$200,Y:<<U_OR1
	nop
	move	a1,P:(FLASH+$1555)	; write $5555,cmd
	rts
;
; Flash addresses
;			INVERTED OUT!	<<8!
;	00000-03FFF	SC0=1 SC1=1	OR1=3	P:$C000-$FFFF
;	04000-07FFF	SC0=0 SC1=1	OR1=2	P:$C000-$FFFF
;	08000-0BFFF	SC0=1 SC1=0	OR1=1	P:$C000-$FFFF
;	0C000-0FFFF	SC0=0 SC1=0	OR1=0	P:$C000-$FFFF <- reset
;	10000-13FFF	SC0=1 SC1=1	OR1=3	X:$C000-$FFFF
;	14000-17FFF	SC0=0 SC1=1	OR1=2	X:$C000-$FFFF
;	18000-1BFFF	SC0=1 SC1=0	OR1=1	X:$C000-$FFFF
;	1C000-1FFFF	SC0=0 SC1=0	OR1=0	X:$C000-$FFFF
;
AUTOSEL	equ	*
	move	#>$90,a1
	jsr	<FMEMCMD
	clr	a	#>$7f7f,x0
	move	P:FLASH,a2		; manifacture code 01 [7 bit]
	rep	#8
	asr	a
	move	P:(FLASH+1),a2		; device code 20      [7 bit]
	rep	#16
	asr	a			; exit A1=$2001
	and	x0,a
	rts
;
READRST	equ	*
	move	#>$F0,a1
	jsr	<FMEMCMD
	move	P:FLASH,a1		; dummy
	rts

; ===================================================================
;
ERASEBK	equ	*		; block nr (0-7) in a1
	move	#FLASH,r1

	move	#>$80,a1
	jsr	<FMEMCMD	; use a1,x0

	jsr	<BUSCYC2
	move	X:<Seccode,a1	; get sector bits for UART
	movep	a1,Y:<<U_OR1	; select sector

	move	#>$30,a1
	jset	#2,X:<Blkno,_ebk1	; blocks in X:space?
	move	a1,P:(r1)
_ebp1	jsr	<WAIT1		; erase starts with t/out=100usec
	move	P:(r1),a1
	jclr	#7,a1,_ebp1
	rts			; done

_ebk1	move	a1,X:(r1)
_ebx1	jsr	<WAIT1		; erase starts with t/out=100usec
	move	X:(r1),a1
	jclr	#7,a1,_ebx1
	rts			; done
;
; -------------------------------------------------------------------
;
WRPDAT	equ	*		; byte data in X1,addr in R1
	move	#>$a0,a1
	jsr	<FMEMCMD	; select byte write, uses x0
	move	X:<Seccode,a1	; get sector bits for UART
	movep	a1,Y:<<U_OR1	; select sector
	nop
	move	x1,P:(r1)	; write
_wpd01	rep	#10
	nop
	move	P:(r1),a1
	eor	x1,a		; check bit 7, equal when done
	btst	#7,a1
	jcs	_wpd01
	rts
;
WRXDAT	equ	*		; byte data in X1,addr in R1
	move	#>$a0,a1
	jsr	<FMEMCMD	; select byte write, uses x0
	move	X:<Seccode,a1	; get sector bits for UART
	movep	a1,Y:<<U_OR1	; select sector
	nop
	move	x1,X:(r1)	; write
_wpd02	rep	#10
	nop
	move	X:(r1),a1
	eor	x1,a		; check bit 7, equal when done
	btst	#7,a1
	jcs	_wpd02
	rts

; ===================================================================
;
; PLL after reset: ckin=5MHz
;
START1  equ     *
	move	#>$1F0009,x0	; ck*10 = 50 MHz
	movep	x0,X:<<M_PCTL
	nop
	nop
	movep   #0,X:<<M_HCR
	movep   #0,X:<<M_PBD
	bset    #1,X:<<M_PBC    ; (re-)enable HI, PB14 I/O
	ori     #3,MR           ; no IRQs
	movec	#0,SP
	andi    #3,MR
	move	#$FFFF,m0

; -------------------------------------------------------
	movep	#$0,X:<<M_PCDDR
	movep	#$0026,X:<<M_SCR	; EXT CK - WDS=010(8N1)
	movep	#$c002,X:<<M_SCCR	; EXT CK - Scale=/3 -> 250 kHz
	movep	#$4100,X:<<M_CRA
	movep	#$0200,X:<<M_CRB
; do not activate SCI/SSI
	movep	#0,X:<<M_PCC
	movep	#>$0824,X:<<M_IPR

; ===================================================================
;
; peripherals on U43 use bits 8-15 !!
;
	movep	#$4448,X:<<M_BCR
	nop
	MEM_MODE0			; set memX=memY

	move	#>$29f010,x0		; id to host
	jsr	<PUTWORD
	jsr	<AUTOSEL		; select FMEM, get a1
	move	a1,x0
	jsr	<PUTWORD
	jsr	<READRST		; restore read mode

	move	#>7,x0
	jsr	<GETWORD		; sector to erase in a1
	and	x0,a
	move	a1,n0
	move	#SECTAB,r0
	move	a1,X:<Blkno		; save block no.
	move	P:(r0+n0),a1		; get select bit code
	move	a1,X:<Seccode

	jsr	<ERASEBK

	move	X:<Blkno,x0
	move	#>$434c00,a1
	or	x0,a
	move	a1,x0
	jsr	<PUTWORD		; back code
;
; now Flash sector is selected - get 16k byte data to write
;
	move	#FLASH,r1
	move	#$4000,r2		; 16k
	jset	#2,X:<Blkno,writeX
writeP	equ	*
	do	r2,endWP
	jsr	<GETWORD		; data in a1, bits 0-7
	move	a1,x1
	jsr	<WRPDAT
	move	(r1)+
endWP	jmp	<endWPX
;
writeX	equ	*
	do	r2,endWX
	jsr	<GETWORD		; data in a1, bits 0-7
	move	a1,x1
	jsr	<WRXDAT
	move	(r1)+
endWX	nop
endWPX	move	r2,x0
	jsr	<PUTWORD		; result back

	jsr	<READRST		; restore read mode

; ===================================================================

	bset    #M_HCIE,X:<<M_HCR    	; set HCIE
	nop
	andi	#$FD,MR			; IRQs lev 1,2 enabled
ELOOP   equ     *
	wait
	jmp     <ELOOP

; ===================================================================

	end

