
; ===================================================================

DTCMon 	ident	1,0
	page	120,60,1,1,4
	opt	cc,cex,intr,mc,md,mex
	lstcol	10,,,,

; ===================================================================
	INCLUDE		'..\glob56.asm'
; ===================================================================
;
CLK56	equ	60		; MHz
PLLMUL	equ	(CLK56/5)-1
TIMDIV	equ	(CLK56*50)	; to get 100us on timer

ADCDAC	equ	0

; ===================================================================
;
; L: variables
;
L_savA0		equ	0
L_timr		equ	1
L_adcdac	equ	2

; X: variables
;
XTEMP		equ	8
X_tf		equ	9
X_pend		equ	10
XP_ch1		equ	11
XP_ch2		equ	12
XP_ch3		equ	13
XP_ch4		equ	14

; X: variables
;
YTEMP		equ	8
Y_cycl		equ	9

; ===================================================================

NULLVEC		macro
		nop
		nop
		endm

ERRVEC		macro
		jsr	>ERROR
		endm

;
; reset loc: byte 0 block 3 Flash (0c000 = P:c000)
;	order: L-M-H, 3 bytes/word
;
	ORG	P:0		; bootstrap from host port

VReset	jmp	>PREBOOT
VStkerr	ERRVEC
VTrace	ERRVEC
VSWI	NULLVEC
VIRQA	NULLVEC
VIRQB	NULLVEC
VSSIr   jsr	>SSIR
VSSIrx  jsr	>SSIRX
VSSIt   NULLVEC
VSSItx	NULLVEC
VSCIr	NULLVEC
VSCIrx	NULLVEC
VSCIt	NULLVEC
VSCIi	NULLVEC
VSCItim	NULLVEC
VNMI	NULLVEC
VHOSTR	ERRVEC
VHOSTT	ERRVEC

VHOSTC	jsr	>PEEK		; 0024	V=$12
; host aux vectors @ P:0026-003E
VHC1	jsr	>POKE		; 0026
VHC2    jsr	>FILL

VHC3    jsr	>HOSTC3		; 002a
VHC4    jsr	>HOSTC4
VHC5    jsr	>HOSTC5
VHC6    jsr	>HOSTC6		; 0030	V=$18
VHC7    jsr	>HOSTC7
VHC8    jsr	>HOSTC8
VHC9    jsr	>HOSTC9
VHC10   jsr	>HOSTC10
VHC11   jsr	>HOSTC11
VTIMER	jsr	>TIMER		; 003c	V=$1e

VILLEG  jsr	>ILLOP		; 003e

; ===================================================================
;
; Error processing
;
ILLOP	move	#$ee,m7
	move	m7,Y:$c30b
ERROR   equ	*
	ori     #3,MR           ; no IRQs
	debug
	jmp	*

; ===================================================================
;
; start user pgm = P:c600, len=0x1355
;
PREBOOT	equ	*
	ori     #3,MR           ; no IRQs
	move	#>($1F0000|PLLMUL),x0	; ck*12 = 60 MHz
	movep	x0,X:<<M_PCTL
	nop
	movec	#$40,omr
	movec	#0,sp
	movep	#$1144,X:<<M_BCR
	move	#$c600,r0
	move	#($10000-$c600)/3,r1
	move	#$80,r4
	do	r1,_pblp0
	do	#3,_pblp1
	movem	P:(r0)+,a2
	rep	#8
	asr	a
_pblp1	movem	a1,P:(r4)+
_pblp0	jmp	<$80

	bsc	$80-*,$ffffff

; ===================================================================
;
; ===================================================================

	org	P:$80,P:$200

	jmp	<START1

; ===================================================================

; wait 64k*33n = 2.16msec
WAIT1	clr	a
	rep	a1
	nop
	rts

; ===================================================================
;
TIMER	equ	*
	move	a10,L:<L_savA0
	move	L:<L_timr,a10
	inc	a
	move	a10,L:<L_timr
	move	L:<L_savA0,a10
	rti

; ===================================================================

SSIRX	equ	*
	btst	#0,X:<<M_SR
SSIR	equ	*
	movep	X:<<M_RX,X:L_adcdac
	nop
; reset SSI
;	movep	#$007,X:<<M_PCC
;	nop
;	movep	#$1c7,X:<<M_PCC
	rti

; ===================================================================

; Get a word from Host Port into A1
;
GETWORD	jclr	#M_HRDF,X:<<M_HSR,GETWORD
	movep	X:<<M_HRX,a1
	rts

;
; Put a word from X0 into Host Port
;
PUTWORD	jclr	#M_HTDE,X:<<M_HSR,PUTWORD
	movep	x0,X:<<M_HTX
	rts

Pkpoka	jsr     <GETWORD		; get space/address <SSAAAA>
	tfr	a,b	a1,X:<XTEMP
	jsr	<GETWORD		; get word count
	move	a1,n0
	move	b1,r0
	rts

;
; PEEK: put block from S:A into Host Port
;
PEEK    equ     *
	jsr     <Pkpoka
	do	n0,Endpeek
	jset	#PP_REG,X:<XTEMP,PeekPE
	jset	#PP_MP,X:<XTEMP,PeekPE
	jset	#PP_MXY,X:<XTEMP,PeekY
PeekX   move    X:(r0)+,x0
	jmp	<Epeek0
PeekY   move    Y:(r0)+,x0
	jmp     <Epeek0
PeekPE	movem   P:(r0)+,x0
Epeek0	jsr     <PUTWORD
	nop
Endpeek	rti

;
; POKE: get block from Host Port into S:A
;
POKE    equ     *
	jsr     <Pkpoka
	do	n0,Endpoke
	jsr     <GETWORD		; get value into A1
	jset	#PP_REG,X:<XTEMP,PokePE
	jset	#PP_MP,X:<XTEMP,PokePE
	jset	#PP_MXY,X:<XTEMP,PokeY
PokeX   move    a1,X:(r0)+
	jmp	<Epoke0
PokeY   move    a1,Y:(r0)+
	jmp	<Epoke0
PokePE	movem   a1,P:(r0)+
Epoke0	nop
Endpoke	rti

;
; FILL: fill block from Host Port into S:A
;
FILL    equ     *
	jsr     <Pkpoka
	jsr     <GETWORD		; get value into A1
	do	n0,Endfill
	jset	#PP_REG,X:<XTEMP,Efill0
	jset	#PP_MP,X:<XTEMP,FillPE
	jset	#PP_MXY,X:<XTEMP,FillY
FillX   move    a1,X:(r0)+
	jmp	<Efill0
FillY   move    a1,Y:(r0)+
	jmp	<Efill0
FillPE	movem   a1,P:(r0)+
Efill0	nop
Endfill	rti

; ===================================================================
;
CODECREG	macro	REG
	movep	#(REG<<8),Y:<<C_IAR
	nop
	endm

CODECDAT	macro	DST
	movep	Y:<<C_IDR,DST
	nop
	endm

CodecXwrite	equ *		; WARNING wait states!
	movep	r0,Y:<<C_IAR
	rep	#6
	nop
	movep	x0,Y:<<C_IDR
	rep	#6
	nop
	rts

CodecXread	equ *		; WARNING wait states!
	movep	r0,Y:<<C_IAR
	rep	#6
	nop
	movep	Y:<<C_IDR,x0
	rep	#6
	nop
	rts

YWRITEA	equ	*
	movep	a1,Y:<<Y_ADRW
	rep	#100		; 3.3u
	nop
	rts

YWRITED	equ	*
	movep	a1,Y:<<Y_DATW
	rep	#700		; 23u
	nop
	rts

YREADS 	equ	*
	movep	Y:<<Y_STAT,y0
	rep	#20
	nop
	rts

; ===================================================================
;
; PLL after reset: ckin=5MHz
;
START1  equ     *
	movep   #0,X:<<M_HCR
	movep   #0,X:<<M_PBD
	movep   #0,X:<<M_PCC
	bset    #1,X:<<M_PBC    ; (re-)enable HI, PB14 I/O
	ori     #3,MR           ; no IRQs
	movec	#0,SP
	andi    #3,MR
;
; Flash addresses
;			INVERTED OUT!	<<8!
;	00000-03FFF	SC0=1 SC1=1	OR1=3	P:$C000-$FFFF
;	04000-07FFF	SC0=0 SC1=1	OR1=2	P:$C000-$FFFF
;	08000-0BFFF	SC0=1 SC1=0	OR1=1	P:$C000-$FFFF
;	0C000-0FFFF	SC0=0 SC1=0	OR1=0	P:$C000-$FFFF
;	10000-13FFF	SC0=1 SC1=1	OR1=3	X:$C000-$FFFF
;	14000-17FFF	SC0=0 SC1=1	OR1=2	X:$C000-$FFFF
;	18000-1BFFF	SC0=1 SC1=0	OR1=1	X:$C000-$FFFF
;	1C000-1FFFF	SC0=0 SC1=0	OR1=0	X:$C000-$FFFF
;
	move	#0,r0
	clr	a
	rep	#256
	move	a,L:(r0)+

; -------------------------------------------------------
;	Configure SCI for ()B, N81
;	System clock is 60.000 MHz
;	Ext.clock is 8.000 MHz
;
; X:SCR [13=TMIE 12=TIE 11=RIE 10=ILIE 9=TE 8=RE 7=WOMS 6=RWU 5=WAKE
;         4=SBK  2-0=WDS]
;
; ========== SCI ==================================
; internal ck= 16*BR
; in ck = 30.0 MHz
; SCLK out = BR
; SCCR value = (ck/64)/BR
; BPS = (f0/64) / ((SCP?8:1)*(CD+1))
;
; -------------------------------------------------------

	movep	#$0,X:<<M_PCDDR
	movep	#$0026,X:<<M_SCR	; EXT CK - WDS=010(8N1)
	movep	#$c002,X:<<M_SCCR	; EXT CK - Scale=/3 -> 250 kHz

; CRA: PSR WL(2) DC(5)  PM(8)
;       0   10   0.0000.0000.0000
	movep	#$4000,X:<<M_CRA
; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCD(4) OF(2)
;	0   0   0  0. 0   1   1   1.0    0   00.00   00
	movep	#$0700,X:<<M_CRB

; --------------------------------------------
;
; IRQ priorities:
;	TIMER= enabled
;	SCI  = disabled
;	SSI  = enabled
;	HOST = level 1 (10)
;	IRQB = disabled, edge trig (100)
;	IRQA = disabled, edge trig (100)
;
;               rr rr rr TT CC SS HH rr rr BB B AAA
;               -----------------------------------
; bit setting = xx.xx|xx.11|00.11|10.xx|xx.10|0.100

	IF ADCDAC
	 movep	#>$033824,X:<<M_IPR
	ELSE
	 movep	#>$030824,X:<<M_IPR
	ENDIF

	move	#$40,r0
	move	#$bf080,x0		; jsr
	move	#>HOSTCX,x1
	do	#32,_hvecs
        move	x0,P:(r0)+
	move	x1,P:(r0)+
_hvecs	nop

	movep	#>$1114,X:<<M_BCR
	nop

; ===================================================================
;
; peripherals on U43 use bits 8-15 !!
;
	move	#UART1,r0
	jsr	<INIT_U
	move	#UART2,r0
	jsr	<INIT_U
	move	#UART3,r0
	jsr	<INIT_U
	move	#UART4,r0
	jsr	<INIT_U

	MEM_MODE1			; set memX!=memY
	clr	a	#QPAGE3,r0
	bset	#U_SCO7,Y:<<U_OR4	; start AD1848
	move	a,Y:$E008		; clear FPGA register
	move	a,X:<X_pend
;
; clear shared RAM, DSP area 300..3FF
;
	rep	#256			; C300..C3FF
	move	a,Y:(r0)+

; timer setup, period = (CK/2)/n = 3000 for 100us@60MHz
	movep	#TIMDIV,X:<<M_TCR
	movep	#0,X:<<M_TCSR
	movep	#3,X:<<M_TCSR
;
; write ident
;
	move	#QPAGE3+8,r0
	move	#>$435444,y0		; 'DTC' reversed
	move	y0,Y:(r0)+
	mpy	y0,#8,a
	move	a1,Y:(r0)+
	mpy	y0,#16,a
	clr	b	a1,Y:(r0)+
	move	b1,Y:(r0)+

	jsr	<OkHost
	jsr	<WAIT1
;
; CodecInit (a)
;
	movep	#>$111a,X:<<M_BCR
	nop
	nop
_u0la	jclr	#15,Y:<<C_IAR,_u1la	; wait for init
	nop
	nop
	jmp	<_u0la
_u1la	nop
;
; CodecInit (b)
;
	move	#0,r0
	move	#$100,n0		; next reg <<8
; Left Input Gain [b0-b3] = 0
; Left Input Src  [b6-b7] = 0  Left Line 1
	move	#0,x0
	jsr	<CodecXwrite		; 0,0
; Right Input Gain [b0-b3] = 0
; Right Input Src  [b6-b7] = 0  Right Line 1
	move	(r0)+n0
	jsr	<CodecXwrite		; 1,0
	move	(r0)+n0
; Left Aux1 Gain [b0-b4] = 0
; Left Aux1 Mute [b7] = 1
	move	#>$8000,x0
	jsr	<CodecXwrite		; 2,$80
; Right Aux1 Gain [b0-b4] = 0
; Right Aux1 Mute [b7] = 1
	move	(r0)+n0
	jsr	<CodecXwrite		; 3,$80
; Left Aux2 Gain [b0-b4] = 0
; Left Aux2 Mute [b7] = 1
	move	(r0)+n0
	jsr	<CodecXwrite		; 4,$80
; Right Aux2 Gain [b0-b4] = 0
; Right Aux2 Mute [b7] = 1
	move	(r0)+n0
	jsr	<CodecXwrite		; 5,$80
; Left DAC Atten [b0-b5] = 0
; Left DAC Mute  [b7] = 1
	move	(r0)+n0
	jsr	<CodecXwrite		; 6,$80
; Right DAC Atten [b0-b5] = 0
; Right DAC Mute  [b7] = 1
	move	(r0)+n0
	jsr	<CodecXwrite		; 7,$80
	move	(r0)+n0
; CSL [b0] = 1 (Xtal2)
; CFS [b1-b3] = 101 (44.1k)
; S/M [b4] = 1 (Stereo)
; C/L [b5] = 0 (Linear)
; FMT [b6] = 1 (16 bit signed PCM)
	move	#>$5b00,x0
	jsr	<CodecXwrite		; 8,$5b
	move	(r0)+n0
; PEN  [b0] = 0 (Playback enable)
; ACAL [b3] = 1 (Autocalib)
	move	#>$0800,x0
	jsr	<CodecXwrite		; 9,$08
	move	(r0)+n0
; CLKTS [b5] = 0
; XCTL0 [b6] = 0
; XCTL1 [b7] = 0
	move	#0,x0
	jsr	<CodecXwrite		; 10,0
; TSSEL [b6] = 0
; FRS   [b7] = 0
	move	#0,x0
	move	#$d00,r0
	jsr	<CodecXwrite		; 13,0
; DME [b0] = 0 (Digital mix enable)
; DMA [b2-b7] = 0 (Digital mix atten)
	move	(r0)+n0
	jsr	<CodecXwrite		; 14,0
;
	move	(r0)+n0
	move	#>$2000,x0
	jsr	<CodecXwrite		; 15,$20
;
	CODECREG	11
	nop
_u2la	jclr	#13,Y:<<C_IDR,_u3la	; wait for autocalib
	nop
	nop
	jmp	<_u2la
_u3la	nop
	jsr	<WAIT1
	move	#>$c000,x0
	move	#$a00,r0
	jsr	<CodecXwrite		; 10,$c0 ->XCTL bits=1

	move	#>$400,a1
	jsr	<YWRITEA
	move	#>$e000,a1
	jsr	<YWRITED

	movep	X:<<M_RX,a1
	movep	X:<<M_RX,a1

; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCKD SCD2-0 OF(2)
;	1   0   1  1. 0   1   1   0.0    0    0    0.00   00
	IF	ADCDAC
	 movep	#$b600,X:<<M_CRB
; activate SCI
	 movep	#$1c7,X:<<M_PCC
	ELSE
	 movep	#$0600,X:<<M_CRB
	 movep	#$007,X:<<M_PCC
	ENDIF

; ===================================================================

	bset    #M_HCIE,X:<<M_HCR    	; set HCIE
	nop
	andi	#$FD,MR			; IRQs lev 1,2 enabled

ELOOP   equ     *
	movep	#>$0416,X:<<M_BCR
;
; save capture state to ext.interface
;
	move	#FPGA+7,r1
	clr	a	#$c347,r0
	move	Y:(r1)-,a1		; E007 bits 20-23, addr H
	rep	#4
	asl	a
	move	Y:(r1)-,a1		; E006 bits 20-23, addr L
	rep	#4
	asl	a
	clr	a	a2,Y:(r0)-	; to C347
	move	Y:(r1)-,a1		; E005 bits 20-23, data H
	rep	#4
	asl	a
	move	Y:(r1)-,a1		; E004 bits 20-23, data L
	rep	#4
	asl	a
	clr	a	a2,Y:(r0)-	; to C346
	move	Y:(r1),a1		; E003 bits 20-23, FPGA data
	rep	#3
	asl	a
	asl	a	#>7,y1
	clr	a	a2,Y:(r0)-	; to C345
	movep	Y:<<IRQP,y0
	mpy	y0,#13,a
	not	a
	and	y1,a
	move	a1,Y:(r0)-		; IRQ PAL bit 13-15 to C344
	jsr	<YREADS
	mpy	y0,#13,a
	and	y1,a
	move	a1,Y:(r0)-		; YM3812 status (bits 5-7) to C343
;
; ========= process UART outputs =========
;
	move	Y:F_TF,a1		; M401 transmit flag (1=full)
	move	a1,X:<X_tf
	move	#QR401,r0		; C300
	move	#2,n0
	move	#F_CW,r1		; C300..3,write to clear W flag
	move	#4,n1			; offset to C304..7, clear R flag
	move	#U_LSR,n2

	move	Y:QRUART+1,y1
	jsset	#0,y1,M401ua1
	jset	#0,y1,_euloo1		; priority=C338
	jsset	#20,X:<X_tf,M401ch1

_euloo1	move	(r0)+n0
	move	(r1)+
	move	Y:QRUART+3,y1
	jsset	#0,y1,M401ua2
	jset	#0,y1,_euloo2		; priority=C33A
	jsset	#21,X:<X_tf,M401ch2

_euloo2	move	(r0)+n0
	move	(r1)+
	move	Y:QRUART+5,y1
	jsset	#0,y1,M401ua3
	jset	#0,y1,_euloo3		; priority=C33C
	jsset	#22,X:<X_tf,M401ch3

_euloo3	move	(r0)+n0
	move	(r1)+
	move	Y:QRUART+7,y1
	jsset	#0,y1,M401ua4
	jset	#0,y1,_euloo4		; priority=C33E
	jsset	#23,X:<X_tf,M401ch4

_euloo4	nop
;
; ========================================
;
	movep	#>$0116,X:<<M_BCR
	nop
_eqhc0	move	Y:QI_CVR,y1
	jclr	#7,y1,_eloo4
	move	#>$3f,a
	and	y1,a
	lsl	a	a1,Y:QI_CVR	; clr bit 7
	move	a1,r0
	jne	<_eloo3
; host command vector 0 at QRAM:341 (write 0x80)
	debug
	jmp	<_eqhc0
_eloo3	move	(r0)+			; point to word 2 of vector
	move	P:(r0),a
	tst	a	a1,r0		; nothing if 0 (fast interrupt)
	jeq	<_eloo4
	jsr	(r0)

_eloo4	equ	*
;
; save timer - for 100u resol cycle=2^48/10^4 sec = 7Gsec = 222yrs
;
	move	#QRTIMR,r0
	move	Y:<L_timr,y0
	move	y0,Y:(r0)+
	mpy	y0,#8,a
	move	a1,Y:(r0)+
	mpy	y0,#16,a
	move	a1,Y:(r0)+
	move	X:<L_timr,y0
	move	y0,Y:(r0)+
	mpy	y0,#8,a
	move	a1,Y:(r0)+
	mpy	y0,#16,a
	move	a1,Y:(r0)+
;
; ---------- from here execution is every n cycles (Y_cycl counter)
;
	bchg	#0,Y:<Y_cycl
	jcs	<EWAIT
	bchg	#1,Y:<Y_cycl
	jcs	<EWAIT

	IF	ADCDAC
;
; get/set AD7869 from Y:c354-8
;
	 move	#$c358,r1
	 movep	X:<<M_RX,a1

	 jset	#0,Y:(r1),_ada01
	 move	#$c356,r0
	 move	X:<L_adcdac,x0
	 mpy	x0,#8,a
	 move	a1,Y:(r0)+
	 mpy	x0,#16,a
	 move	a1,Y:(r0)+
	 bset	#0,Y:(r1)

_ada01	 jclr	#1,Y:(r1),_ada02
	 move	#$c354,r0
	 clr	a
	 move	Y:(r0)+,a2
	 rep	#8
	 asr	a
	 move	Y:(r0)+,a2
	 rep	#8
	 asr	a			; data: hh.ll.00
	 move	a1,Y:<L_adcdac
	 bclr	#1,Y:(r1)

_ada02	 move	Y:<L_adcdac,a1
	 movep	a1,X:<<M_TX
	 movep	#0,Y:<<AD7869		; dummy

	ENDIF
;
; save UART bit inputs
;
	move	#$c350,r0
;----------------------------------------------------------------
;  Modem Status Register
;	[b15]	[b14]	[b13]	[b12]	[b11] [b10] [b9]  [b8]
;	DCD	RI	DSR	CTS	dDCD  TERI  dDSR  dCTS
;----------------------------------------------------------------
;[U1]	SCI1	SIO23	SCI0    SIO23
;----------------------------------------------------------------
	move	Y:U_IR1,y0
	move	#>$50,y1	; hardware invert mask
	mpy	y0,#8,a
	eor	y1,a
	move	a1,Y:(r0)+
;----------------------------------------------------------------
;[U2]	SCI3	SIO22	SCI2    SIO22
;----------------------------------------------------------------
	move	Y:U_IR2,y0
	move	#>$d0,y1	; hardware invert mask
	mpy	y0,#8,a
	eor	y1,a
	move	a1,Y:(r0)+
;----------------------------------------------------------------
;[U3]	SIO16	SIO16	SCI4	SCI5
;----------------------------------------------------------------
	move	Y:U_IR3,y0
	move	#>$10,y1	; hardware invert mask
	mpy	y0,#8,a
	eor	y1,a
	move	a1,Y:(r0)+
;----------------------------------------------------------------
;[U4]	SIO20	SIO20	SCI6	SCI7
;----------------------------------------------------------------
	move	Y:U_IR4,y0
	move	#>$30,y1	; hardware invert mask
	mpy	y0,#8,a
	eor	y1,a
	move	a1,Y:(r0)+

EWAIT	wait
	jmp     <ELOOP


; ===================================================================
;
; Init UARTs for communication - r0=UART base
;
;  for (k=0; k<0x100; k++) {
;    *COM1_scratchpad=k;
;    if (*COM1_scratchpad!=k) return(0);
;   }
;  *COM1_scratchpad=1;
;
;  *COM1_line_ctrl=0x83;
;  *COM1_baudL=MIDIBAUD;
;  *COM1_baudH=0;
;  *COM1_modem_ctrl=0;
;  *COM1_line_ctrl=0x03;
;  k=*COM1_data;
;  k=*COM1_line_stat;
;
;  *COM1_modem_ctrl=0x10;	/* loopback */
;  for (k=0; k<0x100; k++) {
;    *COM1_data=k;
;    wait(8);
;    if (*COM1_data!=k) return(0);
;   }
;  *COM1_modem_ctrl=0;
;  return(1);
;
; peripherals on U43 use bits 8-15 !!
;
INIT_U	equ	*
	movep	X:<<M_BCR,x1		; save
	movep	#>$1116,X:<<M_BCR
	move	#U_LCR,n0
	move	#>$8300,y0		; DLAB=1
	move	y0,Y:(r0+n0)
	move	#U_DLL,n0
	move	#>$1000,y0		; baudL = 16 for 8MHz
	move	y0,Y:(r0+n0)
	move	#U_DLM,n0
	move	#0,y0			; baudH
	move	y0,Y:(r0+n0)
	move	#U_FCR,n0
	move	#>$8100,y0		; FIFO on, recv=8
	move	y0,Y:(r0+n0)
	move	#U_MCR,n0
	move	#0,y0
	move	y0,Y:(r0+n0)
	move	#U_LCR,n0
	move	#>$0300,y0		; DLAB=0
	move	y0,Y:(r0+n0)
	move	#U_RBR,n0
	nop
	move	Y:(r0+n0),y0
	move	#U_LSR,n0
	nop
	move	Y:(r0+n0),y0
	movep	x1,X:<<M_BCR
	rts

; ===================================================================
;
; C338 direct UART1
;
M401ua1	equ	*		; don't change Y1
	clr	a	#UART1,r2
	move	Y:QRUART,y0
	jclr	#13,Y:(r2+n2),_m4ua1r	; no wait, next cycle
	move	a,Y:QRUART+1
	mpy	y0,#16,a	; to bits 8-15 of a0
	move	a0,Y:(r2)	; transmit
_m4ua1r	rts

;
; C330 MPU401 emulation UART1
;
M401ch1	equ	*		; byte received from PC MPU401#1 (b20)
	move	Y:F_AF,a1
	move	#UART1,r2
	move	X:<XP_ch1,a0
	jset	#20,X:<X_pend,_m4ch1t
	jset	#20,a1,_m4ch1a	; control received
	move	Y:(r0),y0	; get data from C300, bits 0-7
	mpy	y0,#16,a	; to bits 8-15 of a0
_m4ch1t	jclr	#13,Y:(r2+n2),_m4ch1p
	move	a0,Y:(r2)	; transmit
	bclr	#20,X:<X_pend	; clr xmit pending
	move	a1,Y:(r1)	; clear xmit flag, dummy write
	rts
_m4ch1p	move	a0,X:<XP_ch1
	bset	#20,X:<X_pend	; set xmit pending
	rts

_m4ch1a	move	(r0)+
	move	Y:(r0)-,a2	; get control byte from C301, restore r0!
	move	#>$fe,a1	; ack
	move	a1,Y:(r0)	; write ack into C300
	move	a1,Y:(r1)	; clear xmit flag, dummy write
	move	a1,Y:(r1+n1)	; clear recv flag, dummy write
	rts

; -------------------------------------------------------------------
;
; C33A direct UART2
;
M401ua2	equ	*		; don't change Y1
	clr	a	#UART2,r2
	move	Y:QRUART+2,y0
	jclr	#13,Y:(r2+n2),_m4ua2r	; no wait, next cycle
	move	a,Y:QRUART+3
	mpy	y0,#16,a	; to bits 8-15 of a0
	move	a0,Y:(r2)	; transmit
_m4ua2r	rts

;
; C332 MPU401 emulation UART2
;
M401ch2	equ	*		; byte received from PC MPU401#2 (b21)
	move	Y:F_AF,a1
	move	#UART2,r2
	move	X:<XP_ch2,a0
	jset	#21,X:<X_pend,_m4ch2t
	jset	#21,a1,_m4ch2a	; control received
	move	Y:(r0),y0	; get data from C302, bits 0-7
	mpy	y0,#16,a	; to bits 8-15 of a0
_m4ch2t	jclr	#13,Y:(r2+n2),_m4ch2p
	move	a0,Y:(r2)	; transmit
	bclr	#21,X:<X_pend	; clr xmit pending
	move	a1,Y:(r1)	; clear xmit flag, dummy write
	rts
_m4ch2p	move	a0,X:<XP_ch2
	bset	#21,X:<X_pend	; set xmit pending
	rts

_m4ch2a	move	(r0)+
	move	Y:(r0)-,a2	; get control byte from C303, restore r0!
	move	#>$fe,a1	; ack
	move	a1,Y:(r0)	; write ack into C302
	move	a1,Y:(r1)	; clear xmit flag, dummy write
	move	a1,Y:(r1+n1)	; clear recv flag, dummy write
	rts

; -------------------------------------------------------------------
;
; C33C direct UART3
;
M401ua3	equ	*		; don't change Y1
	clr	a	#UART3,r2
	move	Y:QRUART+4,y0
	jclr	#13,Y:(r2+n2),_m4ua3r	; no wait, next cycle
	move	a,Y:QRUART+5
	mpy	y0,#16,a	; to bits 8-15 of a0
	move	a0,Y:(r2)	; transmit
_m4ua3r	rts

;
; C334 MPU401 emulation UART3
;
M401ch3	equ	*		; byte received from PC MPU401#3 (b22)
	move	Y:F_AF,a1
	move	#UART3,r2
	move	X:<XP_ch3,a0
	jset	#22,X:<X_pend,_m4ch3t
	jset	#22,a1,_m4ch3a	; control received
	move	Y:(r0),y0	; get data from C304, bits 0-7
	mpy	y0,#16,a	; to bits 8-15 of a0
_m4ch3t	jclr	#13,Y:(r2+n2),_m4ch3p
	move	a0,Y:(r2)	; transmit
	bclr	#22,X:<X_pend	; clr xmit pending
	move	a1,Y:(r1)	; clear xmit flag, dummy write
	rts
_m4ch3p	move	a0,X:<XP_ch3
	bset	#22,X:<X_pend	; set xmit pending
	rts

_m4ch3a	move	(r0)+
	move	Y:(r0)-,a2	; get control byte from C305, restore r0!
	move	#>$fe,a1	; ack
	move	a1,Y:(r0)	; write ack into C304
	move	a1,Y:(r1)	; clear xmit flag, dummy write
	move	a1,Y:(r1+n1)	; clear recv flag, dummy write
	rts

; -------------------------------------------------------------------
;
; C33E direct UART4
;
M401ua4	equ	*		; don't change Y1
	clr	a	#UART4,r2
	move	Y:QRUART+6,y0
	jclr	#13,Y:(r2+n2),_m4ua4r	; no wait, next cycle
	move	a,Y:QRUART+7
	mpy	y0,#16,a	; to bits 8-15 of a0
	move	a0,Y:(r2)	; transmit
_m4ua4r	rts

;
; C336 MPU401 emulation UART4
;
M401ch4	equ	*		; byte received from PC MPU401#4 (b23)
	move	Y:F_AF,a1
	move	#UART4,r2
	move	X:<XP_ch4,a0
	jset	#23,X:<X_pend,_m4ch4t
	jset	#23,a1,_m4ch4a	; control received
	move	Y:(r0),y0	; get data from C306, bits 0-7
	mpy	y0,#16,a	; to bits 8-15 of a0
_m4ch4t	jclr	#13,Y:(r2+n2),_m4ch4p
	move	a0,Y:(r2)	; transmit
	bclr	#23,X:<X_pend	; clr xmit pending
	move	a1,Y:(r1)	; clear xmit flag, dummy write
	rts
_m4ch4p	move	a0,X:<XP_ch4
	bset	#23,X:<X_pend	; set xmit pending
	rts

_m4ch4a	move	(r0)+
	move	Y:(r0)-,a2	; get control byte from C307, restore r0!
	move	#>$fe,a1	; ack
	move	a1,Y:(r0)	; write ack into C308
	move	a1,Y:(r1)	; clear xmit flag, dummy write
	move	a1,Y:(r1+n1)	; clear recv flag, dummy write
	rts

; ===================================================================

HOSTC3	equ	*
HOSTC4	equ	*
HOSTC5	equ	*
HOSTC6	equ	*
HOSTC7	equ	*
HOSTC8	equ	*
HOSTC9	equ	*
HOSTC10	equ	*
HOSTC11	equ	*
HOSTC12	equ	*
HOSTCX	equ	*
	rti

; ===================================================================

OkHost	equ	*
	move	#>$56002,x0
	move	x0,X:$8000
	move	X:$8000,x0
	movep	x0,X:<<M_HTX
	rts

; ===================================================================

	end

