
; ===================================================================

DTCBoot	ident	1,0
	page	120,60,1,1,4
	opt	cc,cex,intr,mc,md,mex
	lstcol	10,,,,

; ===================================================================
	INCLUDE		'..\glob56.asm'
; ===================================================================
;
; X: variables
;
T_r1		equ	0
TEMP		equ	1

; ===================================================================

NULLVEC		macro
		nop
		nop
		endm

ERRVEC		macro
		jsr	>ERROR
		endm


	ORG	P:0		; bootstrap from host port

VReset	jmp	>START1		; 0000
VStkerr	ERRVEC
VTrace	ERRVEC
VSWI	ERRVEC
VIRQA	NULLVEC
VIRQB	NULLVEC
VSSIr   NULLVEC
VSSIrx  NULLVEC
VSSIt   NULLVEC
VSSItx	NULLVEC
VSCIr	NULLVEC
VSCIrx	NULLVEC
VSCIt	NULLVEC
VSCIi	NULLVEC
VSCItim	NULLVEC
VNMI	NULLVEC
VHOSTR	ERRVEC
VHOSTT	ERRVEC

VHOSTC	jsr	>PEEK
; host aux vectors @ P:0026-003E
VHC1	jsr	>POKE		; 0026
VHC2    jsr	>FILL

VHC3    NULLVEC
VHC4    NULLVEC
VHC5    NULLVEC
VHC6    NULLVEC
VHC7    NULLVEC
VHC8    NULLVEC
VHC9    NULLVEC
VHC10   NULLVEC
VHC11   NULLVEC
VHC12   NULLVEC

VILLEG  stop
	stop

; ===================================================================

; wait 64k*50n = 3.28u
WAIT1	clr	a
	rep	a1
	nop
	rts

; ===================================================================

; Get a word from Host Port into A1
;
GETWORD	jclr	#M_HRDF,X:<<M_HSR,GETWORD
	movep	X:<<M_HRX,a1
	rts

;
; Put a word from X0 into Host Port
;
PUTWORD	jclr	#M_HTDE,X:<<M_HSR,PUTWORD
	movep	x0,X:<<M_HRX
	rts

Pkpoka	jsr     <GETWORD		; get space/address <SSAAAA>
	tfr	a,b	a1,X:<TEMP
	jsr	<GETWORD		; get word count
	move	a1,n0
	move	b1,r0
	rts

;
; PEEK: put block from S:A into Host Port
;
PEEK    equ     *
	jsr     <Pkpoka
	do	n0,Endpeek
	jset	#PP_REG,X:<TEMP,PeekPE
	jset	#PP_MP,X:<TEMP,PeekPE
	jset	#PP_MXY,X:<TEMP,PeekY
PeekX   move    X:(r0)+,x0
	jmp	<Epeek0
PeekY   move    Y:(r0)+,x0
	jmp     <Epeek0
PeekPE	movem   P:(r0)+,x0
Epeek0	jsr     <PUTWORD
	nop
Endpeek	rti

;
; POKE: get block from Host Port into S:A
;
POKE    equ     *
	jsr     <Pkpoka
	do	n0,Endpoke
	jsr     <GETWORD		; get value into A1
	jset	#PP_REG,X:<TEMP,PokePE
	jset	#PP_MP,X:<TEMP,PokePE
	jset	#PP_MXY,X:<TEMP,PokeY
PokeX   move    a1,X:(r0)+
	jmp	<Epoke0
PokeY   move    a1,Y:(r0)+
	jmp	<Epoke0
PokePE	movem   a1,P:(r0)+
Epoke0	nop
Endpoke	rti

;
; FILL: fill block from Host Port into S:A
;
FILL    equ     *
	jsr     <Pkpoka
	jsr     <GETWORD		; get value into A1
	do	n0,Endfill
	jset	#PP_REG,X:<TEMP,Efill0
	jset	#PP_MP,X:<TEMP,FillPE
	jset	#PP_MXY,X:<TEMP,FillY
FillX   move    a1,X:(r0)+
	jmp	<Efill0
FillY   move    a1,Y:(r0)+
	jmp	<Efill0
FillPE	movem   a1,P:(r0)+
Efill0	nop
Endfill	rti

; ===================================================================
;
; Error processing
;
ERROR   bset    #M_HF2,X:<<M_HCR     ; set error flag (HF23 = 11)
;	bset	#M_HF3,X:<<M_HCR
;	ori     #3,MR           ; no IRQs
;	nop
	dc	$200		; debug
	stop
	rti

; ===================================================================
;
; Init UARTs for communication - r0=UART base
;
;  for (k=0; k<0x100; k++) {
;    *COM1_scratchpad=k;
;    if (*COM1_scratchpad!=k) return(0);
;   }
;  *COM1_scratchpad=1;
;
;  *COM1_line_ctrl=0x83;
;  *COM1_baudL=MIDIBAUD;
;  *COM1_baudH=0;
;  *COM1_modem_ctrl=0;
;  *COM1_line_ctrl=0x03;
;  k=*COM1_data;
;  k=*COM1_line_stat;
;
;  *COM1_modem_ctrl=0x10;	/* loopback */
;  for (k=0; k<0x100; k++) {
;    *COM1_data=k;
;    wait(8);
;    if (*COM1_data!=k) return(0);
;   }
;  *COM1_modem_ctrl=0;
;  return(1);
;
; peripherals on U43 use bits 8-15 !!
;
INIT_U	equ	*
	move	#>$ff00,x0		; mask
	movep	X:<<M_BCR,x1		; save
	move	#0,r1			; err
	movep	#>$1116,X:<<M_BCR
	move	#U_SCR,n0		; scratchpad
	move	#>$5aa5,a
	do	#8,iulp1
	move	a,b
	move	a1,Y:(r0+n0)
	move	Y:(r0+n0),y0		; must have bits 8-15 equal
	eor	y0,b
	and	x0,b
	jeq	<iuts1
	move	(r1)+
iuts1	lsl	a
iulp1	nop
	move	#U_LCR,n0
	move	#>$8300,y0		; DLAB=1
	move	y0,Y:(r0+n0)
	move	#U_DLL,n0
	move	#>$1000,y0		; baudL = 16 for 8MHz
	move	y0,Y:(r0+n0)
	move	#U_DLM,n0
	move	#>$0000,y0		; baudH
	move	y0,Y:(r0+n0)
	move	#U_MCR,n0
	move	#>$0000,y0
	move	y0,Y:(r0+n0)
	move	#U_LCR,n0
	move	#>$0300,y0		; DLAB=0
	move	y0,Y:(r0+n0)
	move	#U_RBR,n0
	nop
	move	Y:(r0+n0),y0
	move	#U_LSR,n0
	nop
	move	Y:(r0+n0),y0
	movep	x1,X:<<M_BCR
	rts

; ===================================================================
;
; PLL after reset: ckin=5MHz
;
START1  equ     *
	move	#>$1F000a,x0	; ck*13 = 65 MHz
	movep	x0,X:<<M_PCTL
	nop
	nop
	movep   #0,X:<<M_HCR
	movep   #0,X:<<M_PBD
	bset    #1,X:<<M_PBC    ; (re-)enable HI, PB14 I/O
	ori     #3,MR           ; no IRQs
	movec	#0,SP
	andi    #3,MR
	move	#$FFFF,m0

; @65 MHz	tc=30.8n
;		1W=46.2n
;		2W=61.5n
;		3W=76.9n
;		4W=92.3n

	movep	#$1114,X:<<M_BCR	; X=50n Y=66n P=50n Pe=100n
	move	#0,r0
	clr	a
	rep	#256
	move	a,L:(r0)+

; -------------------------------------------------------
;	Configure SCI for ()B, N81
;	System clock is 60.000 MHz
;	Ext.clock is 8.000 MHz
;
; X:SCR [13=TMIE 12=TIE 11=RIE 10=ILIE 9=TE 8=RE 7=WOMS 6=RWU 5=WAKE
;         4=SBK  2-0=WDS]
;
; ========== SCI ==================================
; internal ck= 16*BR
; in ck = 30.0 MHz
; SCLK out = BR
; SCCR value = (ck/64)/BR
; BPS = (f0/64) / ((SCP?8:1)*(CD+1))
;
; -------------------------------------------------------

	movep	#$0,X:<<M_PCDDR
	movep	#$0026,X:<<M_SCR	; EXT CK - WDS=010(8N1)
	movep	#$c002,X:<<M_SCCR	; EXT CK - Scale=/3 -> 250 kHz

;	movep	#$0002,X:<<M_SCR	; INT CK - WDS=010(8N1)
;	movep	#$001d,X:<<M_SCCR	; INT CK - Scale=/30 -> 31.25 kHz

; CRA: PSR WL(2) DC(5)  PM(8)
;       0   10   0.0000.0000.0000
	movep	#$4100,X:<<M_CRA
; CRB: RIE TIE RE TE MOD GCK SYN FSL(2) SHFD SCD(4) OF(2)
;	0   0   0  0. 0   0   1   0.0    0   00.00   00
	movep	#$0200,X:<<M_CRB

; now activate SCI/SSI
	movep	#$007,X:<<M_PCC

; --------------------------------------------

; IRQ priorities:
;	SCI  = disabled
;	SSI  = disabled
;	HOST = level 1 (10)
;	IRQB = disabled, edge trig (100)
;	IRQA = disabled, edge trig (100)
; bit setting = 00.00|10.xx|xx.10|0.100		(x=0)

	movep	#>$0824,X:<<M_IPR

	movep	#>$1114,X:<<M_BCR
	nop

; ===================================================================
;
; peripherals on U43 use bits 8-15 !!
;
	clr	a	#UART1,r0
	move	a,X:<T_r1
	jsr	<INIT_U
	move	r1,x0
	move	X:<T_r1,a
	add	x0,a
	move	a1,X:<T_r1
	move	#UART2,r0
	jsr	<INIT_U
	move	r1,x0
	move	X:<T_r1,a
	add	x0,a
	move	a1,X:<T_r1
	move	#UART3,r0
	jsr	<INIT_U
	move	r1,x0
	move	X:<T_r1,a
	add	x0,a
	move	a1,X:<T_r1
	move	#UART4,r0
	jsr	<INIT_U
	move	r1,x0
	move	X:<T_r1,a
	add	x0,a
	move	a1,X:<T_r1

	MEM_MODE0			; set memX=memY
	nop
	bset	#U_SCO7,Y:<<U_OR4	; stop AD1848
;
	movep	#>$0014,X:<<M_BCR
	move	X:<T_r1,a
	move	#>$56002,x0
	or	x0,a
	move	a1,X:$1000
	nop
	move	Y:$1000,x0
	jsr	<PUTWORD

	movep	#>$0046,X:<<M_BCR
	move	#UART1,r0
	move	#>$8000,x0	; >>8
	move	#>$ff,y0
	do	#40,u1loop
	move	Y:(r0)+,y1
	mpy	x0,y1,a
	and	y0,a
_u2la	jclr	#M_HTDE,X:<<M_HSR,_u2la
	movep	a1,X:<<M_HRX
u1loop	nop
	rep	#100
	nop
;
	move	#0,r0
	move	#0,r1
	move	#0,r2
	move	#0,r3
	move	#0,r4
	move	#0,r5
	move	#0,r6
	move	#0,r7
	move	#0,n0
	move	#0,n1
	move	#0,n2
	move	#0,n3
	move	#0,n4
	move	#0,n5
	move	#0,n6
	move	#0,n7
	move	#$ffff,m0
	move	#$ffff,m1
	move	#$ffff,m2
	move	#$ffff,m3
	move	#$ffff,m4
	move	#$ffff,m5
	move	#$ffff,m6
	move	#$ffff,m7
; ===================================================================

	movep	#>$4048,X:<<M_BCR
	bset    #M_HCIE,X:<<M_HCR    	; set HCIE
	nop
	andi	#$FD,MR			; IRQs lev 1,2 enabled
ELOOP   equ     *
	wait
	jmp     <ELOOP

; ===================================================================

	end

