
#include "..\dtc2.h"

#undef M401TRC
#define DEBUG

unsigned long _mflag[5] = {
	0x00000l,	/* X */
	0x10000l,	/* Y */
	0x20000l,	/* P */
	0x40000l,
	0x80000l
	};

extern unsigned long *DSPBUF;
extern char far *QRAM;

extern int OnCEonerr,iscapt;
int testOnCE(int log);

#define ONCECALL(e)	{ printf("\a\n"); if (OnCEonerr) testOnCE(1); return(e); }

/* ----------------------------------------------------------------- */
/*	LOD file read						     */
/* ----------------------------------------------------------------- */

static rectyp findkeyw (char *t)
{
 char typessym[6][12] =
      { "START","END","DATA","BLOCKDATA","SYMBOL","COMMENT" };
 int i,found;

  found=0;
  for (i=0; (i<6)&&(!found); i++) {
    found = !stricmp(t,typessym[i]);
   }
  if (!found) return(sNorec);
   else return((rectyp)(i-1));
}


int load56(char *fname)
{
 char t[81];
 int i;
 rectyp blktype = sNorec;
 char mspace[3];
 unsigned int len;
 unsigned long *buf=DSPBUF;
 long start,V;
 FILE *fp;

  if ((fp = fopen(fname,"rt")) == NULL) return(1);
  printf("Loading DSP file %s...",fname);
  memset(DSPBUF,0xff,DBUFSIZ*sizeof(long));

#ifdef DEBUG
  fprintf(stderr,"\n");
#endif
  do {
   if (fscanf(fp,"%s",t)==1) {
     if (*t == '_') {
       blktype = findkeyw(&(t[1]));
       switch (blktype) {
	 case sData:
	     fscanf(fp,"%s",mspace);
	     fscanf(fp,"%4lX",&start);
	     len=0; i=1;
	     buf=DSPBUF+start;
	     while (i) {
	       i = fscanf(fp,"%6lX",&V);
	       if ((toupper(*mspace)=='P') && i) { *buf++=V; len++; }
	      }
#ifdef DEBUG
	     fprintf(stderr,"\tblk %c:%04lx l=%x\n",*mspace,start,len);
#endif
	     break;
	 case sBlock:
	     fscanf(fp,"%s",mspace);
	     fscanf(fp,"%4lX",&start);
	     fscanf(fp,"%4x",&len);
	     fscanf(fp,"%6lX",&V);
	     if (toupper(*mspace)=='P') {
	       buf=DSPBUF+start;
#ifdef DEBUG
	       fprintf(stderr,"\tfill %06lx %c:%04lx l=%x\n",V,*mspace,start,len);
#endif
	       for (i=0; i<len; i++) *buf++=V;
	      }
	     break;
	 default: break;
	}
      }
    }
  } while (!(feof(fp) || (blktype==sEnd)));
 fclose(fp);
 printf("Ok\n");
 return(0);
}


/* ------------------------------------------------------------------- */


static void near dspwrite(unsigned long v)
{
  while((inp(HI_ISR)&0xf2)==0);
  asm {	mov	dx,345h;
	mov	ax,word ptr v+2;
	cli;
	out	dx,al;
	mov	ax,word ptr v;
	xchg	al,ah;
	inc	dx;
	out	dx,al;
	xchg	al,ah;
	inc	dx;
	out	dx,al;
	sti;
      }
}


static int near dspwrite_t(unsigned long v,long t)
{
  while (((inp(HI_ISR)&0xf2)==0)&&(--t)); if (t==0) return(1);
  asm {	mov	dx,345h;
	mov	ax,word ptr v+2;
	cli;
	out	dx,al;
	mov	ax,word ptr v;
	xchg	al,ah;
	inc	dx;
	out	dx,al;
	xchg	al,ah;
	inc	dx;
	out	dx,al;
	sti;
      }
  return(0);
}


static int near dspIswrite(long t)
{
  while (((inp(HI_ISR)&0xf2)==0)&&(--t));
  return(t==0);
}


static long near dspread(void)
{
 long v;

  while((inp(HI_ISR)&0xf1)==0)
    if (inp(OnCEstat)&4) { ONCECALL(1); }
  asm {	mov	dx,345h;
	cli;
	in	al,dx;
	xor	cx,cx;
	mov	cl,al;
	inc	dx;
	in	al,dx;
	mov	ah,al;
	inc	dx;
	in	al,dx;
	sti;
	mov	word ptr v,ax;
	mov	word ptr v+2,cx;
       }
  return(v);
}


static long near dspread_t(long t)
{
 long v;

  while (((inp(HI_ISR)&0xf1)==0)&&(--t))
    if (inp(OnCEstat)&4) { ONCECALL(1); }
  if (t==0) return(-1l);
  asm {	mov	dx,345h;
	cli;
	in	al,dx;
	xor	cx,cx;
	mov	cl,al;
	inc	dx;
	in	al,dx;
	mov	ah,al;
	inc	dx;
	in	al,dx;
	sti;
	mov	word ptr v,ax;
	mov	word ptr v+2,cx;
       }
  return(v);
}


static int near dspIsread(long t)
{
  while (((inp(HI_ISR)&0xf1)==0)&&(--t))
    if (inp(OnCEstat)&4) { ONCECALL(1); }
  return(t==0);
}


static void near DSPcommand(int c)
{
  while (inp(HI_CVR)&0x80);
  outp(HI_CVR,(c|0x80));
  while (inp(HI_CVR)&0x80);
}


static long DSPpeek(int s,unsigned int a)
{
  DSPcommand(HC_Peek);
  dspwrite(_mflag[s]|a);
  dspwrite(1);
  return(dspread());
}


static unsigned long *DSPblkpeek(int s,unsigned int a,int n,unsigned long *buf)
{
 unsigned long *p = buf;

  DSPcommand(HC_Peek);
  dspwrite(_mflag[s]|a);
  dspwrite(n);
  while (n--) *p++ = dspread();
  return(buf);
}


static void DSPpoke(int s,unsigned int a,long v)
{
  DSPcommand(HC_Poke);
  dspwrite(_mflag[s]|a);
  dspwrite(1);
  dspwrite(v);
}


static void DSPfill(int s,unsigned int a,int n,long v)
{
  DSPcommand(HC_Fill);
  dspwrite(_mflag[s]|a);
  dspwrite(n);
  dspwrite(v);
}


static int bootDSP(char *fname)
{
 int n,t;
 unsigned long *p;
 unsigned long v;

  if (load56(fname)) return(1);
  outportb(oDMODE,0);
  outportb(oDRES,0);	/* reset DSP  */
  delay(100);
  outportb(oDRES,1);	/* start DSP  */

  p = DSPBUF;
  for (n=0; n<512; n++) {
    v=*p++;
    t=10000; while (((inp(HI_ISR)&0xf2)==0) && (--t));
    if (t==0) { printf("#%d\n",n); return(1); }
    disable();
    outp(HI_TXM,(v>>8)); outp(HI_TXM,(v>>8));
    outp(HI_TXH,(v>>16)); outp(HI_TXH,(v>>16));
    outp(HI_TXL,v);
    enable();
   }
  outportb(OnCEstat,0);		/* set DR=1, clear ACK */
  delay(1);	/* wait for DSP to reinitialize */
  return(0);
}


/* ----------------------------------------------------------------- */


int DSPtest1(void)
{
 int i,j,f;
 long t,v;
 static char filen[]=FILET1;

  outportb(oDRES,1);	/* start DSP  */
  delay(10);
  printf("DSP: ");
  for (i=0; i<8; i++)
    printf("%02x ",inportb(DSP56+i));
  f=1;
  for (i=0; i<16; i++) {
    outp(DSP56+3,i);
    if (inp(DSP56+3)!=i) { f=0; break; }
   }
  if (f) printf(" reset Ok"); else printf(" reset ERR i=%d",i);
  printf("\n");
  outportb(oDRES,0);	/* reset DSP  */
  if (!f) return(1);

  if (bootDSP(filen)) {
    printf("Error booting DSP: %s\n",filen);
    ONCECALL(1);
   }

  v=dspread_t(500000);
  if (v<0) {
    printf("DSP init timeout, HF=%02x\n",inportb(HI_ISR));
    if (OnCEonerr) testOnCE(1); else {
      for (i=0; i<8; i++)
	printf("%02x ",inp(DSP56+i));
      printf("\n");
     }
    outportb(oDRES,0);	/* reset DSP  */
    return(1);
   }
  printf("DSP init says: %06lx\n",v);
  if (v!=0x56002l) ONCECALL(1);

  for (i=0; i<5; i++) {
    printf("%04x: ",0xffc0|(i<<3));
    for (j=0; j<8; j++) {
      printf("%02x ",(dspread_t(20000)&0xff));
     }
    printf("\n");
   }

  return(0);
}


/* ----------------------------------------------------------------- */


int DSPtest2a(void)
{
 int i,j,f;
 long t,v1,v2;
 static char filen[]=FILET2;

  if (bootDSP(filen)) {
    printf("Error booting DSP: %s\n",filen);
    ONCECALL(1);
   }

  if (dspIsread(1000000)) {
    printf("DSP init timeout, HF=%02x\n",inportb(HI_ISR));
    if (OnCEonerr) testOnCE(1); else {
      for (i=0; i<8; i++)
	printf("%02x ",inp(DSP56+i));
      printf("\n");
     }
    outportb(oDRES,0);	/* reset DSP  */
    return(1);
   }
  for (i=0; i<4; i++) {
    printf("Test %d: ",i);
    v1=dspread_t(200000)&0xffffff;
    v2=dspread_t(20000)&0xffffff;
    printf("%06lx %06lx\n",v1,v2);
    if (v1!=0l) printf("\a");
   }
  printf("FLASH id= %02x ",(int)(dspread_t(20000)&0xff));
  printf("%02x ",(int)(dspread_t(20000)&0xff));
  printf("%02x\n",(int)(dspread_t(20000)&0xff));

  return(0);
}


/* ----------------------------------------------------------------- */


int DSPtest2b(void)
{
 int i,j,f;
 long t,v1,v2;
 static char filen[]=FILET3;

  if (bootDSP(filen)) {
    printf("Error booting DSP: %s\n",filen);
    ONCECALL(1);
   }

  if (dspIsread(1000000)) {
    printf("DSP init timeout, HF=%02x\n",inportb(HI_ISR));
    if (OnCEonerr) testOnCE(1); else {
      for (i=0; i<8; i++)
	printf("%02x ",inp(DSP56+i));
      printf("\n");
     }
    outportb(oDRES,0);	/* reset DSP  */
    return(1);
   }
  for (i=0; i<4; i++) {
    printf("Test %d: ",i);
    v1=dspread_t(200000)&0xffffff;
    v2=dspread_t(20000)&0xffffff;
    printf("%06lx %06lx\n",v1,v2);
    if (v1!=0l) printf("\a");
   }
  printf("FLASH id= %02x ",(int)(dspread_t(20000)&0xff));
  printf("%02x ",(int)(dspread_t(20000)&0xff));
  printf("%02x\n",(int)(dspread_t(20000)&0xff));

  return(0);
}


/* ----------------------------------------------------------------- */


int DSPtest3(void)
{
 int i,j,f;
 long t,v;
 static char filen[]=FILET4;

  if (bootDSP(filen)) {
    printf("Error booting DSP: %s\n",filen);
    ONCECALL(1);
   }
  if (dspIsread(1000000)) {
    printf("DSP init timeout, HF=%02x\n",inportb(HI_ISR));
    if (OnCEonerr) testOnCE(1); else {
      for (i=0; i<8; i++)
	printf("%02x ",inp(DSP56+i));
      printf("\n");
     }
    outportb(oDRES,0);	/* reset DSP  */
    return(1);
   }
  v=dspread_t(20000)&0xffff;
  printf("Test AD%04lx:\n",v);
  if (v!=0x1848) ONCECALL(1);
  for (i=0; i<16; i++) {
    v=dspread_t(200000);
    printf("%02x ",(v>>8)&0xff);
   }
  printf("\n");
  printf("OPL2 stat = %02x\n",(dspread_t(20000)>>13)&7);

  return(0);
}


/* ----------------------------------------------------------------- */


int DSPtest4(void)
{
 int i,j,a,err;
 long t;
 unsigned char b,v;
 static char filen[]=FILET5;

  outport(FPGA,8);	/* reset M401 logic */
  outport(FPGA,0);

  if (bootDSP(filen)) {
    printf("Error booting DSP: %s\n",filen);
    ONCECALL(1);
   }

  t=dspread_t(500000);
  if (t<0) {
    printf("DSP init timeout, HF=%02x\n",inportb(HI_ISR));
    if (OnCEonerr) testOnCE(1); else {
      for (i=0; i<8; i++)
	printf("%02x ",inp(DSP56+i));
      printf("\n");
     }
    outportb(oDRES,0);	/* reset DSP  */
    return(1);
   }
  printf("Test %06lx:\n",t);

  printf("TFR=%x ",(dspread()>>20)&15);
  printf("RFR=%x ",(dspread()>>20)&15);
  printf("AFR=%x\n",(dspread()>>20)&15);

  err=0;
  for (j=0; j<4096; j++) {
    a=M401;
    v=j&0xff; if (v==0) printf(".");
    for (i=0; i<4; i++) {
      t=100000; while ((inportb(a+1)&0x40)&&(--t));
      if (t==0) { err++; printf("W%04d:%d",j,i); } /*else putch('.');*/
      outportb(a,v);
      t=100000; while ((inportb(a+1)&0x80)&&(--t));
      if (t==0) { err++; printf("R%04d:%d",j,i); } /*else putch('.');*/
      b=inportb(a);
      if ((b^v)!=0xff) { err++; putch('D'); }
      t=100000; while ((inportb(a+1)&0x40)&&(--t));
      if (t==0) { err++; printf("W%04d:%d",j,i); } /*else putch('.');*/
      outportb(a+1,v);
      t=100000; while ((inportb(a+1)&0x80)&&(--t));
      if (t==0) { err++; printf("R%04d:%d",j,i); } /*else putch('.');*/
      b=inportb(a);
      if (b!=0xfe) { err++; putch('A'); }
      a+=2;
      v^=0xff;
      if (err) ONCECALL(1);
     }
   }
  if (err) printf("\n%d",err); else printf("no");
  printf(" errs in xmit/recv M401 port %d\n",i+1);

  return(0);
}


/* ----------------------------------------------------------------- */


int DSPtest5(void)
{
 int i,port,err;
 long t,v;
 char far *mem = QRAM;
 static char filen[]=FILET6;

  err=0;
  if (bootDSP(filen)) {
    printf("Error booting DSP: %s\n",filen);
    ONCECALL(1);
   }
  if (dspIsread(1000000)) {
    printf("DSP init timeout, HF=%02x\n",inportb(HI_ISR));
    if (OnCEonerr) testOnCE(1); else {
      for (i=0; i<8; i++)
	printf("%02x ",inp(DSP56+i));
      printf("\n");
     }
    outportb(oDRES,0);	/* reset DSP  */
    return(1);
   }
  v=dspread_t(20000)&0xffffff;
  printf("Test %06lx:\n",v);
  if (v!=0x425553l) ONCECALL(1);

  port=0x3bc;
  outportb(FPGA,0xa0);
  for (i=0; i<48; i++) {
    asm	{	mov dx,port;
		mov ax,i;
		out dx,al;
		out dx,al;
		out dx,al;
		out dx,al }
   }
  outportb(FPGA,0);
  if (iscapt) {
    for (i=0; i<256; i+=2) {
      printf("%02x%02x ",mem[i],mem[i+1]);
     }
    printf("\n%02x\n",mem[0x200]);
   }
  return(err);
}


/* ----------------------------------------------------------------- */


int DSPview(void)
{
 char cmlin[128];
 char *p;
 int i,j,ms,n,err;
 unsigned long a,v;

  for (;;) {
    printf(">");
    gets(cmlin);
    p=cmlin; while(isspace(*p)) p++;
    switch(tolower(*p++)) {
      case 'q': return(0);
      case 'i': while (isspace(*p)) p++;
		err=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0; break;
		  case 'y': ms=1; break;
		  case 'p': ms=2; break;
		  default:  err=1;
		 }
		if (*p==':') p++; else err=1;
		if (!err) {
		  if (sscanf(p,"%lx",&a)==1) {
		    v = (DSPpeek(ms,a)&0xffffff);
		   }
		  else err=1;
		 }
		if (err) printf("ERR\n");
		 else printf("%06lx\n",v);
		break;
      case 'd': while (isspace(*p)) p++;
		err=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0; break;
		  case 'y': ms=1; break;
		  case 'p': ms=2; break;
		  default:  err=1;
		 }
		if (*p==':') p++; else err=1;
		if (!err) {
		  err=1;
		  if (sscanf(p,"%lx",&a)==1) {
		    while ((*p)&&(!isspace(*p))) p++;
		    while ((*p)&&(isspace(*p))) p++;
		    if ((*p==0)||(sscanf(p,"%x",&n)!=1)) n=64;
		    err=0;
		   }
		 }
		if (err) printf("ERR\n");
		 else {
		   DSPblkpeek(ms,a,n,DSPBUF);
		   i=0; j=0;
		   while (n--) {
		     if (j==0) printf("%04x:",a);
		     printf(" %06lx",DSPBUF[i++]&0xffffff);
		     j++; a++;
		     if (j==8) { printf("\n"); j=0; }
		    }
		  }
		break;
      case 'o': while (isspace(*p)) p++;
		err=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0; break;
		  case 'y': ms=1; break;
		  case 'p': ms=2; break;
		  default:  err=1;
		 }
		if (*p==':') p++; else err=1;
		if (!err) {
		  err=1;
		  if (sscanf(p,"%lx",&a)==1) {
		    while (!isspace(*p)) p++;
		    while (isspace(*p)) p++;
		    if (sscanf(p,"%lx",&v)==1) err=0;
		   }
		 }
		if (err) printf("ERR\n");
		 else DSPpoke(ms,a,v);
		break;
      case 'f': while (isspace(*p)) p++;
		err=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0; break;
		  case 'y': ms=1; break;
		  case 'p': ms=2; break;
		  default:  err=1;
		 }
		if (*p==':') p++; else err=1;
		if (!err) {
		  err=1;
		  if (sscanf(p,"%lx",&a)==1) {
		    while ((*p)&&(!isspace(*p))) p++;
		    while ((*p)&&(isspace(*p))) p++;
		    if (sscanf(p,"%lx",&v)==1) {
		      err=0;
		      while ((*p)&&(!isspace(*p))) p++;
		      while ((*p)&&(isspace(*p))) p++;
		      if ((*p==0)||(sscanf(p,"%x",&n)!=1)) n=1;
		     }
		   }
		 }
		if (err) printf("ERR\n");
		 else DSPfill(ms,a,n,v);
		break;
      default:  printf("<I>nput s:addr       <O>utput s:addr val\n");
		printf("<D>ump s:addr n      <F>ill s:addr val n\n");
		break;
     }
   }
}


/* ----------------------------------------------------------------- */

