
/* ================================================================ */

/* ================================================================ */

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <ctype.h>
#include <dir.h>

#undef  TLONG

typedef enum { sStart,sEnd,sData,sBlock,sSymb,sComm,sNorec } rectyp;

char sourc[80] = "twi56.lod";
char destc[80] = "twi56.i";
char tabnam[32]= "DSPTAB";

char *BYTEN;
long *buf;
FILE *fe;


rectyp findkeyw (char *t)
{
 char typessym[6][12] =
      { "START","END","DATA","BLOCKDATA","SYMBOL","COMMENT" };
 int i,found;

  found=0;
  for (i=0; (i<6)&&(!found); i++) {
    found = !stricmp(t,typessym[i]);
   }
  if (!found) return(sNorec);
   else return((rectyp)(i-1));
}



int twfeed (long start, unsigned len, long *p)
{
 static int lpos=0;
 int i;
 long v;
 unsigned char h,m,l;

  for (i=0; i<len; i++) {
    if (lpos==0) fprintf(fe,"\t  ");
    v = *p++;
#ifdef TLONG
    fprintf(fe,"0x%06lx,",v);
    if ((++lpos)==5) { lpos=0; fprintf(fe,"\n  "); }
#else
    l = v; v>>=8;
    m = v; v>>=8;
    h = v;
    fprintf(fe,"0x%02x,0x%02x,0x%02x,",h,m,l);
    if ((++lpos)==4) { lpos=0; fprintf(fe,"\n  "); }
#endif
   }
  return(1);
}



int load56(char *fname, long *buf, int (*F)(long,unsigned,long *))
{
 char t[81];
 int i;
 rectyp blktype = sNorec;
 char mspace[3];
 unsigned int len;
 long start,V;
 long *p;
 FILE *fp;

 if ((fp = fopen(fname,"rt")) == NULL) return(0);
 printf("Loading DSP file %s...",fname);

 do {
   if (fscanf(fp,"%s",t)==1) {
     if (*t == '_') {
       blktype = findkeyw(&(t[1]));
       switch (blktype) {
	 case sData:
	     fscanf(fp,"%s",mspace);
	     fscanf(fp,"%4X",&start);
	     len=0; p=buf; i=1;
	     while (i) {
	       i = fscanf(fp,"%6lX",p++);
	       if (i) len++;
	      }
	     if (!F(start,len,buf)) return(0);
	     break;
	 case sBlock:
	     fscanf(fp,"%s",mspace);
	     fscanf(fp,"%4lX",&start);
	     fscanf(fp,"%4x",&len);
	     fscanf(fp,"%6lX",&V);
	     for (i=0; i<len; i++) buf[i]=V;
	     if (!F(start,len,buf)) return(0);
	     break;
	 default: break;
	}
      }
    }
  } while (!(feof(fp) || (blktype==sEnd)));
 fclose(fp);
 printf("Ok\n");
 return(1);
}


/* ================================================================ */

void main(int argc,char *argv[])
{
 char *p;
 FILE *ft;

  if ((BYTEN = malloc(8192))==NULL) exit(1);
  if ((buf = malloc(8192*sizeof(long)))==NULL) exit(1);
  memset(BYTEN,0xff,8192);

  if (argc==0) {
    printf("Use: LOD2I <source>[.lod] <dest>[.i] <tabname>\n");
    exit(1);
   }
  if (argc>1) {
    strcpy(sourc,argv[1]);
    p=sourc; while ((*p!=0)&&(*p!='.')) p++;
    strcpy(p,".lod");
    ft=fopen(sourc,"rb");
    if (ft==NULL) {
      printf("Where is %s?\n",sourc); exit(1);
     }
    fclose(ft);
    if (argc>2) {
      strcpy(destc,argv[2]);
      p=destc; while ((*p!=0)&&(*p!='.')) p++;
      strcpy(p,".i");
      if (argc>3) {
	strcpy(tabnam,argv[3]); strupr(tabnam);
       }
     }
    else {
      strcpy(destc,sourc);
      p=destc; while ((*p!=0)&&(*p!='.')) p++;
      strcpy(p,".i");
     }
   }

  fe = fopen(destc,"wt");
#ifdef TLONG
  fprintf(fe,"\nlong %s[] =\n\t{\n",tabnam);
#else
  fprintf(fe,"\nchar %s[] =\n\t{\n",tabnam);
#endif

  load56 (sourc,buf,twfeed);

  fprintf(fe,"\t};\n\n");
  fclose (fe);
}
